<?php
/**
 * This project has been generated by nuts generator
 * nuts has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 */


namespace Base;

use Provider\IAM\Core\Request\CoreRequest;
use Provider\IAM\Core\Response\CoreResponse;
use Provider\Response\Results;
use Symfony\Component\Console\Exception\RuntimeException;


class BaseController
{
    protected $baseModel = "";
    protected $baseHelper = "";
    protected $model;
    protected $helper;
    protected $response;

    public function __construct()
    {
        if ($this->baseModel == "") {
            throw new RuntimeException("baseModel isnot Intialized");
        } else if ($this->baseHelper == "") {
            throw new RuntimeException("baseHelper isnot Intialized");
        }
        $this->model = new $this->baseModel();
        $this->helper = new $this->baseHelper();
        $this->response = new Results();
    }

    public function index(CoreRequest $request, CoreResponse $response, $args)
    {
        $data = $this->model->getData();
        return $response->success($data, SUCCESS);
    }

    public function paging(CoreRequest $request, CoreResponse $response, $args)
    {
        $input = $request->getParsedBody();
        $data = $this->helper->paging($input);
        return $response->success($data, SUCCESS);
    }

    public function show(CoreRequest $request, CoreResponse $response, $args)
    {
        $data = $this->helper->show($args["id"]);
        return $response->success($data, SUCCESS);
    }

    public function update(CoreRequest $request, CoreResponse $response, $args)
    {
        $input = $request->getParsedBody();
        $data = $this->helper->update($args["id"], $input);
        return $response->success($data, DATA_UPDATED);
    }

    public function delete(CoreRequest $request, CoreResponse $response, $args)
    {
        $data = $this->helper->delete($args["id"]);
        return $response->success($data, DATA_DELETED);
    }

    public function store(CoreRequest $request, CoreResponse $response, $args)
    {
        $input = $request->getParsedBody();
        $data = $this->helper->store($input);
        return $response->success($data, DATA_CREATED);
    }


}